```This file is part of LionsTooth.

LionsTooth is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
any later version.

LionsTooth is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with LionsTooth.  If not, see <http://www.gnu.org/licenses/>.```

 ---- 

# LionsTooth (WIP)
Diaspora client (Python, Qt, Diaspy)

**It's still in a very early stage, help is welcome :-)**

 ----

## What it currently can do

### General
* View gifs
* Download podlist
* Choose pod
* Save login settings
* Save window size on resize
* Cache images

### Stream
* Display streams (stream, aspects, activity, mentions, followed_tags, public)
 - StatusMessage, Reshare, Photos, Poll
* Add older posts to stream if scroll is at 90%
* Add new posts to stream by clicking refresh button in the header (not done periodical yet.)

### Posts
* View posts and publish post
* Interactions (Like, share)
* Controls (Hide, Delete, Mute, Subscribe)
* View comments and publish comment

### People profile
* Display profile
* Load stream
* Add/remove user to/from aspect(s)

### Followed tags
* Display followed tags
* Display recently viewed tags
* Add tag
* Delete tag

### Notifications
* View notifications
* Toggle notifications

### Search
* Search tags and people

 ----

## TODO (for now, list will be updated when more comes to mind)
### General
* Touchscreen support
* Small screen view: change post_widget layout when width gets smaller then 600px (maybe also change header layout)
* Store fullscreen state in config and restore it at start
* Parse links like https://{pod_netloc}/posts/{post_guid} and change them to permalinks
* Create a list for each aspect wich contains all the pods of the user in that aspect (so we can show a list of pods wich your post if shared with if selecting a aspect)
* Accessbility options like icon and font sizes
* ~~New comment doesn't insert as last item.~~ (on refresh post this is still accurate)
* ~~On new comment interaction counter doesn't update automatic.~~
* Tray icon
* Add liked and commented buttons to stream selectors 'Activity'
* Option to view markdown of posts
* ~~Loading icon doesn't always disapear~~
* Embeded video's
* Rename icon's not by color but by status, so notify_white becomes notify_normal and notify_red becomes notify_active
* Rename/split/cleanup most functions in main.py and replace them to the place where they belong
* Default avatars
* Register at pod
* ~~Remove cache after time + clear cache button~~
* Periodical update posts (and if implemented other pages) with QTimer
* ~~Check if downloaded images are indeed images~~
* ~~Set max download size for images~~
* Set max timeout on connections
* Hovercard widget
* Save images (so detect right click event on images and show menu with options)
* ~~Upload photo's~~
* Go back to top button in streams
* Use wallet to store credentials
* Setupscript
* First start wizard?
* plugin funtionality?
* Optional: Libnotify
* Optional: Camera functions to make photo's / video's
* Clean up code

### Known issues
* ~~GIF's in reshares don't stop when post is not visible.~~
* ~~If link clicked in comment, the text dissapears.~~
* Notify and message icon in header are small on systems with smaller resolution (or maybe it's the DPI).
* ~~Connect button sometimes crashes the program (Disconnect button too, need to reset things proper). [see main.py def disconnect]~~
* Adding/removing a (new) contact doesn't add to contacts (until restart of program)
* Adding/removing a (new) photo doesn't add to people page (until restart of program)
* ~~Not all images are displayed in photo_browser (they appear to be text files containing "Not Found" in cache ;-))~~
* Inline images won't work, it could be but then we can't support animated GIF's. Maybe there is a workaround, don't know yet.
* Notification timeago doesn't get updated.
* ~~Comment tags are not clickable.~~
* New comment sometimes don't appear as last comment.
* Sometimes it segfaults, this is probably due a image-thread tries to set image for widget that is removed. So we need to be able to cancel/kill threads and disconnect their signals.
* Try to share before first stream loaded finished disables the share button.

### Connection
* Proper exception handling

### Stream
* If first loading stream failes due to whatever it is not possible to reload now.
* ~~Page's keep requesting more posts even if there aren't any left.~~
* Stop GIF's when on page leave
* Collapse all posts button

### Post
* ~~~Update post and it's comments~~~ on a timer when post is visable and main window isn't inactive for 2 hours or so
* Resize / use different size img (small, medium, large) in photo_browser widget for photo if Window resized
* NSFW, OpenGraph, Video's
* Controls (Report) for comments too.
* Post links https:// (open window with question what to do with it)
* Save scroll position when expanding post and restore when collapsed again
* ~~Able to set selected comment_id wich results in setting scroll of the page so that that comment is on top.~~

### Photo Browser
* ~~Full screen view with option to view maximum size with scrollbars if needed~~

### Contacts page
* search

### People profile
* Contacts button functionality
* Block button
* ~~Display photo browser~~ make photo browser prettier
* Refresh object and data.
* if aspect: mention button wich opens markdown editor with the mention as start
* if aspect: message button wich opens new message to aspect
* if own_profile: edit profile button etc.
* if own_profile: show button to contacts (manage aspects)

### Notifications
* page with all notifications and connect 'show all' button to it
* ~~bug: new notifications appear at end of the list~~

### Conversations
* everything
* OpenPGP/GPG option

### Settings
* /user/edit
* /profile/edit
* /privacy
* /services
* api/openid_connect/user_applications ???
* set proxy for everything and option to set proxy for remote content (remote asin images not from your pod, if the pod hasn't enabled Camo: https://wiki.diasporafoundation.org/Installation/Camo)
* default post and comment collapse behaviour options
* option to export_profile / export_photos
* option to delete account

### Translations
* everything

### Theming
* create color palettes and implement them (should be all in same place)
* create system where different color palette packs can be easly switched

### Markdown editor
* Maybe I'm going to write a all-in-one markdown editor with wysiwyg, still sketching. If it worksout I'll also create a standalone version.
* ~~Polls~~
* ~~Photo upload~~
* Location
* Some checks when adding markdown through buttons can't hurt. Like check if same selection is already bold or not etc.
* ~~Mentions search after typing @ (escape \\@)~~ comments TODO


### Get in file TODO's
*In LionsTooth directory:*
```grep -rnw --exclude-dir='^\..*$' --exclude-dir='__pycache__' --exclude-dir='diaspy' --exclude-dir='design' --exclude-dir='cache' ./ -e 'TODO'```

 ----

## Requirements
LionsTooth		https://github.com/CYBERDEViLNL/LionsTooth  
~~diaspy			https://github.com/marekjm/diaspy~~ will use official repo in later stage  
diaspy			https://github.com/CYBERDEViLNL/diaspy/  
  
Requirement	| Arch				| Debian Stretch
--------------- | ----------------- | ---------------
python3		| python		| python3
PIL		| python-pillow		| python3-pil
PyQt5		| python-pyqt5		| python3-pyqt5
\-		| \-			| pyqt5-dev-tools
requests	| python-requests	| python3-requests
setuptools	| python-setuptools	| python3-setuptools
urllib		| python-urllib3	| python3-urllib3
certifi		 | python-certifi	| python3-certifi
markdown	| python-markdown	| python3-markdown
BeautifulSoup | python-beautifulsoup4 | python3-bs4
Qt5 SVG		| qt5-svg 			| python3-pyqt5.qtsvg 

**Install LionsTooth requirements** 

***Debian Stretch***
```
apt-get install python3 python3-pil python3-pyqt5 python3-requests \
python3-setuptools python3-urllib3 python3-certifi python3-markdown \
pyqt5-dev-tools python3-bs4 python3-pyqt5.qtsvg
```

***Arch***
```
pacman -S python python-pillow python-pyqt5 python-requests \
python-setuptools python-urllib3 python-certifi python-markdown \
python-beautifulsoup4 qt5-svg
```

 ----

**Install Diaspy requirements (that didn't install with LionsTooth dependencies)**

***Debian Stretch***
```
apt-get install python3-dateutil
```

***Arch***
```
pacman -S python-dateutil
```

 ----

**Get LionsTooth and Diaspy**
```
git clone https://github.com/CYBERDEViLNL/LionsTooth
cd LionsTooth
svn checkout https://github.com/CYBERDEViLNL/diaspy/trunk/diaspy diaspy
```

 ----

## Convert ui files
```
pyuic5 -o design/ui_main_window.py design/ui_main_window.ui
pyuic5 -o design/ui_post.py design/ui_post.ui
pyuic5 -o design/ui_podlist.py design/ui_podlist.ui
pyuic5 -o design/ui_photo_browser.py design/ui_photo_browser.ui
pyuic5 -o design/ui_post_interaction_bar.py design/ui_post_interaction_bar.ui
pyuic5 -o design/ui_header.py design/ui_header.ui
pyuic5 -o design/ui_open_graph.py design/ui_open_graph.ui
pyuic5 -o design/ui_profile.py design/ui_profile.ui
pyuic5 -o design/ui_side_menu.py design/ui_side_menu.ui
pyuic5 -o design/ui_stream_selector.py design/ui_stream_selector.ui
pyuic5 -o design/ui_stream.py design/ui_stream.ui
pyuic5 -o design/ui_notification.py design/ui_notification.ui
pyuic5 -o design/ui_notifications.py design/ui_notifications.ui
pyuic5 -o design/ui_comment.py design/ui_comment.ui
pyuic5 -o design/ui_comments.py design/ui_comments.ui
pyuic5 -o design/ui_poll.py design/ui_poll.ui
pyuic5 -o design/ui_poll_option.py design/ui_poll_option.ui
pyuic5 -o design/ui_markdown_viewer.py design/ui_markdown_viewer.ui
pyuic5 -o design/ui_markdown_editor.py design/ui_markdown_editor.ui
pyuic5 -o design/ui_post_controls.py design/ui_post_controls.ui
pyuic5 -o design/ui_contacts.py design/ui_contacts.ui
pyuic5 -o design/ui_contact.py design/ui_contact.ui
pyuic5 -o design/settings/ui_cache.py design/settings/ui_cache.ui
```

 ----

## Create resource file for icons
```
pyrcc5 icons.qrc -o icons_rc.py
```

 ----

## Start
```
python3 main.py
```
