# -*- coding: utf-8 -*-
"""
This file is part of LionsTooth.

LionsTooth is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
any later version.

LionsTooth is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with LionsTooth.  If not, see <http://www.gnu.org/licenses/>.
"""
from PyQt5 import QtCore, QtGui, QtWidgets
from PyQt5.QtCore import pyqtSignal

from widgets.stream import stream as stream_widget
from widgets.post_widget import post_widget

class single_post(stream_widget):
	post_set = pyqtSignal()
	def __init__(self, thread_pool, parent=None):
		stream_widget.__init__(self, parent=parent)
		self.name = "single_post"
		self.thread_pool = thread_pool
		self.post = None
		
		self.post_set.connect( self.process_anchor_que )

	def set_post(self, post):
		if self.post:
			self.clear_layout()
		self.post = post
		self.insert_post_widget(post, show_all_comments=True)
		
		uid = post.guid
		if not post.guid:
			uid = post.id
		self.ui.stream_layout.post_widgets[uid].ui.btn_permalink.hide() # would be nice loop haha

		self.post_set.emit()
