"""
This file is part of LionsTooth.

LionsTooth is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
any later version.

LionsTooth is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with LionsTooth.  If not, see <http://www.gnu.org/licenses/>.
"""
from PyQt5 import QtCore, QtGui, QtWidgets
from PyQt5.QtCore import pyqtSignal

from design.ui_tag_results import Ui_tag_results
from widgets.shared.tags_box import tags_box

class tag_results(QtWidgets.QWidget):
	tag_clicked = pyqtSignal(str)# tag name
	def __init__(self, parent=None):
		QtWidgets.QWidget.__init__(self, parent)
		self.ui = Ui_tag_results()
		self.ui.setupUi(self)

		self.max_width = 100

		# Tags box
		self.tags_box = tags_box(parent=self)
		sizePolicy = QtWidgets.QSizePolicy(QtWidgets.QSizePolicy.Preferred, QtWidgets.QSizePolicy.Maximum)
		self.tags_box.setSizePolicy(sizePolicy)
		self.ui.results_layout.insertWidget(0, self.tags_box)

		# Hook
		self.tags_box.tag_clicked.connect( self.tag_clicked )

	def set_max_width(self, max_width):
		self.max_width = max_width
		self.tags_box.set_max_width( max_width )

	def clear_layout(self):
		self.tags_box.clear_layout()

	def set_tags(self, tags):
		"""
		param tags: [{"name":"#test"}, .. ]
		type tags: list with dicts
		"""
		self.clear_layout() # clear previous tags
		for tag in tags:
			self.tags_box.add_tag(tag[1:]) # exclude the hashtag
		self.tags_box.adjustSize()
		self.tags_box.set_max_width( self.max_width )
