#!/bin/bash
#	This file is part of LionsTooth.
#
#	LionsTooth is free software: you can redistribute it and/or modify
#	it under the terms of the GNU General Public License as published by
#	the Free Software Foundation, either version 3 of the License, or
#	any later version.
#
#	LionsTooth is distributed in the hope that it will be useful,
#	but WITHOUT ANY WARRANTY; without even the implied warranty of
#	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#	GNU General Public License for more details.
#
#	You should have received a copy of the GNU General Public License
#	along with LionsTooth.  If not, see <http://www.gnu.org/licenses/>.

export LC_ALL=en_US.UTF-8

if [ -z "$(ls -A ./diaspy)" ]; then
	echo "diaspy not found: checking out from svn"
	rm diaspy
	svn checkout https://github.com/CYBERDEViLNL/diaspy/trunk/diaspy diaspy
else
	echo "checking for diaspy updates from svn"
	cd diaspy
	svn up
	cd ..
fi

echo "converting resources file"
pyrcc5 icons.qrc -o icons_rc.py

echo "converting ui files"
# Main window
pyuic5 -o design/ui_main_window.py design/ui_main_window.ui

# Widgets
pyuic5 -o design/ui_post.py design/ui_post.ui
pyuic5 -o design/ui_podlist.py design/ui_podlist.ui
pyuic5 -o design/ui_photo_browser.py design/ui_photo_browser.ui
pyuic5 -o design/ui_post_interaction_bar.py design/ui_post_interaction_bar.ui
pyuic5 -o design/ui_header.py design/ui_header.ui
pyuic5 -o design/ui_open_graph.py design/ui_open_graph.ui
pyuic5 -o design/ui_profile.py design/ui_profile.ui
pyuic5 -o design/ui_side_menu.py design/ui_side_menu.ui
pyuic5 -o design/ui_stream_selector.py design/ui_stream_selector.ui
pyuic5 -o design/ui_stream.py design/ui_stream.ui
pyuic5 -o design/ui_contact.py design/ui_contact.ui
pyuic5 -o design/ui_notification.py design/ui_notification.ui
pyuic5 -o design/ui_notifications.py design/ui_notifications.ui
pyuic5 -o design/ui_comment.py design/ui_comment.ui
pyuic5 -o design/ui_comments.py design/ui_comments.ui
pyuic5 -o design/ui_poll.py design/ui_poll.ui
pyuic5 -o design/ui_poll_option.py design/ui_poll_option.ui
pyuic5 -o design/ui_poll_edit.py design/ui_poll_edit.ui
pyuic5 -o design/ui_poll_edit_option.py design/ui_poll_edit_option.ui
pyuic5 -o design/ui_markdown_viewer.py design/ui_markdown_viewer.ui
pyuic5 -o design/ui_markdown_editor.py design/ui_markdown_editor.ui
pyuic5 -o design/ui_post_controls.py design/ui_post_controls.ui

# Pages
pyuic5 -o design/ui_contacts.py design/ui_contacts.ui
pyuic5 -o design/ui_people_results.py design/ui_people_results.ui
pyuic5 -o design/ui_tag_results.py design/ui_tag_results.ui

# Settings
pyuic5 -o design/settings/ui_cache.py design/settings/ui_cache.ui

echo "starting LionsTooth"
python3 main.py

